﻿using System; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraTreeDataBinding
{
    public partial class Form1 : Form
    {
        private bool  IsInit =true;
        private DataSet ds;

        public Form1()
        {
            InitializeComponent();

            ds = new DataSet();

            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("PID", typeof(int));
            dt.Columns.Add("Name", typeof(string));

            dt.Rows.Add(0, 0, "Value 0");
            dt.Rows.Add(1, 0, "Value 1");
            dt.Rows.Add(2, 1, "Value 2");
            dt.Rows.Add(3, 1, "Value 3");
            dt.Rows.Add(4, 2, "Value 4");
            dt.Rows.Add(5, 2, "Value 5");
            dt.Rows.Add(6, 4, "Value 6");
            dt.Rows.Add(7, 4, "Value 7");
            dt.Rows.Add(8, 0, "Value 8");
            dt.Rows.Add(9, 5, "Value 9");
            dt.Rows.Add(10, 7, "Value 10");

            ds.Tables.Add(dt);

            
            DataRelation dr = new DataRelation("RR", dt.Columns["ID"], dt.Columns["PID"]);
            dr.Nested = true;            
            
            ds.Relations.Add(dr);
            ultraTree1.DataSource = ds.Tables[0];
        }

        private void ultraTree1_InitializeDataNode(object sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
            e.Node.DataColumnSetResolved.Columns["ID"].Visible = false;
            e.Node.DataColumnSetResolved.Columns["PID"].Visible = false;
            if(IsInit) Init(e);
        }

        private void Init(Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
            if (e.Node.Cells["PID"].Text == "0" && e.Node.Index != 0) e.Node.Visible = true;
            else e.Node.Visible = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            IsInit = false;
        }

    }
}
